<?php
/**
 * Kids Activity Center functions and definitions
 *
 * @package Kids Activity Center
 */

if ( ! defined( 'KIDS_ACTIVITY_CENTER_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'KIDS_ACTIVITY_CENTER_VERSION', '1.0.0' );
}

function kids_activity_center_setup() {

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'kids-activity-center' ),
			'social-menu' => esc_html__('Social Menu', 'kids-activity-center'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'kids_activity_center_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'kids_activity_center_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $kids_activity_center_content_width
 */
function kids_activity_center_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'kids_activity_center_content_width', 640 );
}
add_action( 'after_setup_theme', 'kids_activity_center_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function kids_activity_center_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'kids-activity-center' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'kids-activity-center' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'kids-activity-center' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'kids-activity-center' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'kids-activity-center' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'kids-activity-center' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'kids-activity-center' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'kids-activity-center' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'kids_activity_center_widgets_init' );


function kids_activity_center_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */

function kids_activity_center_scripts() {
    // Google Fonts
	$query_args = array(
	    'family' => rawurlencode(
	        'Ubuntu:ital,wght@0,300;0,400;0,500;0,700;1,300;1,400;1,500;1,700|' .
	        'Nunito:ital,wght@0,200..1000;1,200..1000|' .
	        'Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;' .
	        '1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900|' .
	        'Inter:ital,opsz,wght@0,14..32,100..900;1,14..32,100..900|' .
	        'Abril+Fatface'
	    ),
	    'display' => 'swap',
	);
    wp_enqueue_style('kids-activity-center-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), wp_get_theme()->get('Version'));

    // Main stylesheet
    wp_enqueue_style('kids-activity-center-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Add custom inline styles
    require get_parent_theme_file_path('/custom-style.php');
	wp_add_inline_style('kids-activity-center-style', $kids_activity_center_custom_css);

    // RTL styles if needed
    if (file_exists(get_stylesheet_directory() . '/rtl.css')) {
        wp_style_add_data('kids-activity-center-style', 'rtl', 'replace');
    }

    // Navigation script
    wp_enqueue_script('kids-activity-center-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Custom script
    wp_enqueue_script('kids-activity-center-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'kids_activity_center_scripts');

if (!function_exists('kids_activity_center_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function kids_activity_center_related_post($post_id){        
        $kids_activity_center_categories = get_the_category($post_id);
        if ($kids_activity_center_categories) {
            $kids_activity_center_category_ids = array();
            $kids_activity_center_category = get_category($kids_activity_center_category_ids);
            $kids_activity_center_categories = get_the_category($post_id);
            foreach ($kids_activity_center_categories as $kids_activity_center_category) {
                $kids_activity_center_category_ids[] = $kids_activity_center_category->term_id;
            }
            $kids_activity_center_count = $kids_activity_center_category->category_count;
            if ($kids_activity_center_count > 1) { ?>

         	<?php
		$kids_activity_center_related_post_wrap = absint(get_theme_mod('kids_activity_center_enable_related_post', 1));
		if($kids_activity_center_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('kids_activity_center_related_post_text', __('Related Post', 'kids-activity-center'))); ?></h2>
                    <?php
                    $kids_activity_center_cat_post_args = array(
                        'category__in' => $kids_activity_center_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'kids_activity_center_related_post_count', '3' ),
                        'post_status' => 'publish',
                        'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $kids_activity_center_featured_query = new WP_Query($kids_activity_center_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($kids_activity_center_featured_query->have_posts()) :

                        while ($kids_activity_center_featured_query->have_posts()) : $kids_activity_center_featured_query->the_post();
                            ?>
                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php kids_activity_center_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $kids_activity_center_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/slider1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $kids_activity_center_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        kids_activity_center_posted_on();
                                        kids_activity_center_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('kids_activity_center_related_posts', 'kids_activity_center_related_post', 10, 1);

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$kids_activity_center_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function kids_activity_center_sanitize_checkbox($kids_activity_center_checked)
{
    // Boolean check.
    return ((isset($kids_activity_center_checked) && true == $kids_activity_center_checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function kids_activity_center_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'kids_activity_center_remove_customize_register', 11 );

/************************************************************************************/

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'kids_activity_center_loop_columns');

if (!function_exists('kids_activity_center_loop_columns')) {

	function kids_activity_center_loop_columns() {

		$kids_activity_center_columns = get_theme_mod( 'kids_activity_center_per_columns', 3 );

		return $kids_activity_center_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'kids_activity_center_per_page', 20 );

function kids_activity_center_per_page( $kids_activity_center_cols ) {

  	$kids_activity_center_cols = get_theme_mod( 'kids_activity_center_product_per_page', 9 );

	return $kids_activity_center_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'kids_activity_center_products_args' );

function kids_activity_center_products_args( $kids_activity_center_args ) {

    $kids_activity_center_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $kids_activity_center_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $kids_activity_center_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function kids_activity_center_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --kids_activity_center_logo_width: <?php echo absint(get_theme_mod('kids_activity_center_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('kids_activity_center_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'kids_activity_center_custom_css' );

function kids_activity_center_sanitize_choices( $kids_activity_center_input, $kids_activity_center_setting ) {
    global $wp_customize; 
    $kids_activity_center_control = $wp_customize->get_control( $kids_activity_center_setting->id ); 
    if ( array_key_exists( $kids_activity_center_input, $kids_activity_center_control->choices ) ) {
        return $kids_activity_center_input;
    } else {
        return $kids_activity_center_setting->default;
    }
}

//Excerpt 
function kids_activity_center_excerpt_function($kids_activity_center_excerpt_count = 35) {
    $kids_activity_center_excerpt = get_the_excerpt();
    $kids_activity_center_text_excerpt = wp_strip_all_tags($kids_activity_center_excerpt);
    $kids_activity_center_excerpt_limit = (int) get_theme_mod('kids_activity_center_excerpt_limit', $kids_activity_center_excerpt_count);
    $kids_activity_center_words = preg_split('/\s+/', $kids_activity_center_text_excerpt); 
    $kids_activity_center_trimmed_words = array_slice($kids_activity_center_words, 0, $kids_activity_center_excerpt_limit);
    $kids_activity_center_theme_excerpt = implode(' ', $kids_activity_center_trimmed_words);

    return $kids_activity_center_theme_excerpt;
}


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function kids_activity_center_enqueue_function() {

    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/kids_activity_center_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/kids_activity_center_config_file.php';

    define('KIDS_ACTIVITY_CENTER_FREE_SUPPORT',__('https://www.revolutionwp.com/products/kids-activity-center','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_PRO_SUPPORT',__('https://www.revolutionwp.com/support/revolution-wp/','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_REVIEW',__('https://wordpress.org/support/theme/kids-activity-center/reviews/','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_BUY_NOW',__('https://www.revolutionwp.com/products/kids-wordpress-theme','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_LIVE_DEMO',__('https://demo.revolutionwp.com/kids-activity-center-pro/','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/kids-activity-center-pro/','kids-activity-center'));
    define('KIDS_ACTIVITY_CENTER_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/kids-activity-center-free/','kids-activity-center'));
    
}
add_action( 'after_setup_theme', 'kids_activity_center_enqueue_function' );



// Add admin notice
function kids_activity_center_admin_notice() { 
    global $pagenow;
    $kids_activity_center_theme_args      = wp_get_theme();
    $kids_activity_center_meta            = get_option( 'kids_activity_center_admin_notice' );
    $name            = $kids_activity_center_theme_args->__get( 'Name' );
    $kids_activity_center_current_screen  = get_current_screen();

    if( !$kids_activity_center_meta ){
        if( is_network_admin() ){
            return;
        }

        if( ! current_user_can( 'manage_options' ) ){
            return;
        } 
        
        if( $kids_activity_center_current_screen->base !== 'appearance_page_kids_activity_center_guide' && 
            $kids_activity_center_current_screen->base !== 'toplevel_page_kidsactivitycenter-demoimport' ) { ?>

            <div class="notice notice-success kids-activity-center-welcome-notice">
                <p class="kids-activity-center-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'kids_activity_center_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'kids-activity-center' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="kids-activity-center-welcome-notice-wrap">
                    <h2 class="kids-activity-center-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $kids_activity_center_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'kids-activity-center' ), $kids_activity_center_theme_name ) );
                        ?>
                    </h2>
                    <p class="kids-activity-center-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'kids-activity-center' ); ?>
                    </p>

                    <div class="kids-activity-center-welcome-info">
                        <div class="kids-activity-center-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'kids-activity-center' ); ?>">
                        </div>

                        <div class="kids-activity-center-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'kids-activity-center' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'kids-activity-center' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=kidsactivitycenter-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'kids-activity-center' ); ?></a></p>
                        </div>

                        <div class="kids-activity-center-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'kids-activity-center' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'kids-activity-center' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=kids-activity-center-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'kids-activity-center' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

    }
}

add_action( 'admin_notices', 'kids_activity_center_admin_notice' );

if( ! function_exists( 'kids_activity_center_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function kids_activity_center_update_admin_notice(){
    if ( isset( $_GET['kids_activity_center_admin_notice'] ) && $_GET['kids_activity_center_admin_notice'] = '1' ) {
        update_option( 'kids_activity_center_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'kids_activity_center_update_admin_notice' );

add_action('after_switch_theme', 'kids_activity_center_setup_options');
function kids_activity_center_setup_options () {
    update_option('kids_activity_center_admin_notice', FALSE );
}

// changelog
function kids_activity_center_get_changelog_from_readme() {
    $kids_activity_center_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($kids_activity_center_file_path)) {
        $kids_activity_center_content = file_get_contents($kids_activity_center_file_path);

        // Extract changelog section
        $kids_activity_center_changelog_start = strpos($kids_activity_center_content, "== Changelog ==");
        $kids_activity_center_changelog = substr($kids_activity_center_content, $kids_activity_center_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $kids_activity_center_changelog, $kids_activity_center_matches, PREG_SET_ORDER);
        
        return $kids_activity_center_matches;
    }
    return [];
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );